/*!
    Document:      common_view.js
    Date started:  12 September 2017
    By:            Matt Fozard
    Purpose:       Quru Image Server viewer utilities and common routines
    Requires:
    Copyright:     Quru Ltd (www.quru.com)
    Licence:

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published
    by the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/
*/
if(!window.QU){QU={version:1,supported:([].forEach!==undefined)&&([].indexOf!==undefined)&&((function(){}).bind!==undefined)&&(Object.keys!==undefined)&&(window.addEventListener!==undefined)&&(window.getComputedStyle!==undefined)&&(window.pageXOffset!==undefined)&&(window.JSON!==undefined)};
QU.id=function(a){if(typeof a==="number"){a=""+a;}if(typeof a==="string"){return document.getElementById(a);
}if(typeof a==="object"){return a;}return null;};QU.elClear=function(a){a=QU.id(a);while(a.firstChild){a.removeChild(a.firstChild);
}return a;};QU.elRemove=function(a){a=QU.id(a);if(a&&a.parentNode){a.parentNode.removeChild(a);}return a;
};QU.elOuterPosition=function(c){c=QU.id(c);var d=c,a=0,b=0;if(d.offsetParent){do{a+=d.offsetLeft;b+=d.offsetTop;
}while(d=d.offsetParent);}return{x:a,y:b,width:c.offsetWidth,height:c.offsetHeight};};QU.elInnerSize=function(c,a){c=QU.id(c);
var d={width:c.clientWidth,height:c.clientHeight};if(!a){var b=window.getComputedStyle(c);d.width-=Math.round(parseFloat(b.paddingLeft)+parseFloat(b.paddingRight));
d.height-=Math.round(parseFloat(b.paddingTop)+parseFloat(b.paddingBottom));d.width=Math.max(d.width,0);
d.height=Math.max(d.height,0);}return d;};QU.elInnerOffsets=function(b){b=QU.id(b);var a=window.getComputedStyle(b);
return{left:Math.round(parseFloat(a.paddingLeft)+parseFloat(a.borderLeftWidth)),right:Math.round(parseFloat(a.paddingRight)+parseFloat(a.borderRightWidth)),top:Math.round(parseFloat(a.paddingTop)+parseFloat(a.borderTopWidth)),bottom:Math.round(parseFloat(a.paddingBottom)+parseFloat(a.borderBottomWidth))};
};QU.elSetClass=function(d,c,e){d=QU.id(d);if(d.classList){if(e){d.classList.add(c);}else{d.classList.remove(c);
}}else{var b=d.className.split(" "),a=b.indexOf(c);if(b.length===1&&b[0]===""){b.length=0;}if(e&&(a===-1)){b.push(c);
}else{if(!e&&(a!==-1)){b.splice(a,1);}}d.className=b.join(" ");}return d;};QU.elHasClass=function(c,b){c=QU.id(c);
if(c.classList){return c.classList.contains(b);}else{var a=c.className.split(" ");return a.indexOf(b)!==-1;
}};QU.elGetStyles=function(c,g){c=QU.id(c);var b,f={};if(g){try{b=window.getComputedStyle(c);}catch(d){}if(b){for(var a=0;
a<g.length;a++){f[g[a]]=b[g[a]];}}}return f;};QU.elSetStyles=function(b,c){b=QU.id(b);if(c){for(var a in c){b.style[a]=c[a];
}}return b;};QU.evPosition=function(b){var c={x:0,y:0},a={x:0,y:0};if(b.type.indexOf("touch")==0||b.type.indexOf("gesture")==0){if(b.touches&&b.touches[0]){var e=b.touches[0];
c.x=e.pageX;c.y=e.pageY;a.x=e.clientX;a.y=e.clientY;}}else{var d=document.documentElement||document.body;
c.x=(b.pageX!=null)?b.pageX:b.clientX+d.scrollLeft;c.y=(b.pageY!=null)?b.pageY:b.clientY+d.scrollTop;
a.x=(b.pageX!=null)?b.pageX-window.pageXOffset:b.clientX;a.y=(b.pageY!=null)?b.pageY-window.pageYOffset:b.clientY;
}return{page:c,viewport:a};};QU.jsonRequest=function(b,e,a,d){var c=new XMLHttpRequest();if("withCredentials" in c){c.open(e,b,true);
c.setRequestHeader("Accept","application/json");}else{if(typeof XDomainRequest!=="undefined"){c=new XDomainRequest();
c._XDR=true;c.onprogress=function(){};c.ontimeout=function(){};c.open(e,b);}else{return null;}}c.onload=function(){if(!c._XDR&&(c.status<200||c.status>=400)){if(d){d(c,c.responseText);
}return;}if(a){var g;try{g=JSON.parse(c.responseText);}catch(f){if(d){d(c,"Invalid JSON: "+f);}return;
}a(c,g);}};c.onerror=function(){if(d){d(c,c.responseText);}};return c;};QU.splitURL=function(d){var a,c,b,e={protocol:"",server:"",path:"",query:"",fragment:""};
a=d.indexOf("//");if(a!==-1){e.protocol=d.substring(0,a+2);d=d.substring(a+2);}a=d.indexOf("/");if(a>=1){e.server=d.substring(0,a);
d=d.substring(a);}c=d.indexOf("?");if(c!==-1){e.path=d.substring(0,c);e.query=d.substring(c+1);b=e.query.indexOf("#");
if(b!==-1){e.fragment=e.query.substring(b+1);e.query=e.query.substring(0,b);}}else{e.path=d;b=e.path.indexOf("#");
if(b!==-1){e.fragment=e.path.substring(b+1);e.path=e.path.substring(0,b);}}return e;};QU.ObjectToQueryString=function(a,c){var d=[];
var b=Object.keys(a);b.forEach(function(g){var h=a[g],f;if(c){g=c+"["+g+"]";}switch(typeof h){case"object":f=QU.ObjectToQueryString(h,g);
break;case"array":var e={};h.forEach(function(k,j){e[j]=k;});f=QU.ObjectToQueryString(e,g);break;default:f=g+"="+encodeURIComponent(h);
}if(h!=null){d.push(f);}});return d.join("&");};QU.QueryStringToObject=function(g,d){if(d===undefined){d=true;
}var a=function(h){return decodeURIComponent(h.replace(/\+/g," "));};var f=true,b=true;var e=g.split(/[&;]/),c={};
if(!e.length){return c;}e.forEach(function(l){var h=l.indexOf("=")+1,j=h?l.substr(h):"",i=h?l.substr(0,h-1).match(/([^\]\[]+|(\B)(?=\]))/g):[l],k=c;
if(!i){return;}if(!d&&!j){return;}if(b){j=a(j);}i.forEach(function(n,m){if(f){n=a(n);}var o=k[n];if(m<i.length-1){k=k[n]=o||{};
}else{if(typeof o==="array"){o.push(j);}else{k[n]=o!=null?[o,j]:j;}}});});return c;};QU.whenReady=function(a){if(document.attachEvent?document.readyState==="complete":document.readyState!=="loading"){a();
}else{document.addEventListener("DOMContentLoaded",a);}};QU.clone=function(a){if((a===null)||(a===undefined)){return a;
}return JSON.parse(JSON.stringify(a));};QU.merge=function(f,e){var d=function(h,i,j){switch(typeof j){case"object":if(typeof h[i]=="object"){QU.merge(h[i],j);
}else{h[i]=QU.clone(j);}break;case"array":h[i]=QU.clone(j);break;default:h[i]=j;}return h;};for(var c=1,a=arguments.length;
c<a;c++){var g=arguments[c];if((g!==null)&&(g!==undefined)){for(var b in g){d(f,b,g[b]);}}}return f;};
}