/*!
 * image-defer.js
 * 
 * A simple dependency-free JavaScript library for implementing deferred (lazy)
 * image loading on a web page.
 * 
 * Source code:   https://github.com/quru/image-defer/
 * Date started:  24 Apr 2017
 * By:            Matt Fozard
 * Copyright:     Quru Ltd (www.quru.com)
 * Licence:
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/
 */
"use strict";
var ImageDefer=ImageDefer||{};(function(b){this.version="0.3";this.options={maxLoaded:b.maxLoaded||100,onImageRequested:b.onImageRequested||null,onImageLoaded:b.onImageLoaded||null,onImageUnloaded:b.onImageUnloaded||null,scrollingStopMillis:b.scrollingStopMillis||500,scrollingSkipRate:b.scrollingSkipRate||0.8};
if(Object.defineProperty){Object.defineProperty(this,"options",{writable:false,configurable:false});}var a={imagesLoaded:0,images:[],maxBucket:0,scrolling:false,resizing:false,scrollInfo:{last:{pos:0,time:0},current:{pos:0,time:0}},scrollChecker:null,resizeChecker:null,lastVisibleBuckets:{start:-1,end:-1}};
var c={unloaded:0,loading:1,loaded:2,unloading:3};this.requestCallBack=function(d){if(window.requestAnimationFrame){requestAnimationFrame(d);
}else{setTimeout(d,20);}}.bind(this);this.lazyLoadImages=function(){var e=this.viewportPos(),d=this.getBuckets(e.top,e.height),f;
if(a.resizing){return;}if((d.start!==a.lastVisibleBuckets.start)||(d.end!==a.lastVisibleBuckets.end)){for(f=d.start;
f<=d.end;f++){if(a.images[f]){a.images[f].forEach(function(g){this.loadImage(g);}.bind(this));}}a.lastVisibleBuckets.start=d.start;
a.lastVisibleBuckets.end=d.end;}}.bind(this);this.trimImages=function(){if(this.options.maxLoaded&&(a.imagesLoaded>this.options.maxLoaded)){var i=this.viewportPos(),g=this.getBuckets(i.top,i.height),h=0,d=(a.imagesLoaded-this.options.maxLoaded),f=this,k;
var e=function(l){for(var m=g.start;m<=g.end;m++){if(a.images[m]&&a.images[m].indexOf(l)!==-1){return true;
}}return false;};var j=function(m){var l=0;if(a.images[m]&&(m<g.start||m>g.end)){a.images[m].forEach(function(n){if(!e(n)){if(f.unloadImage(n)){l++;
}}});}return l;};if(a.scrollInfo.current.pos>a.scrollInfo.last.pos){for(k=0;(k<=a.maxBucket)&&(h<d);k++){h+=j(k);
}}else{for(k=a.maxBucket;(k>=0)&&(h<d);k--){h+=j(k);}}}}.bind(this);this.loadImage=function(d){if(!d._defer_state){if(!d._defer_load_event){d._defer_load_event=function(){this.onImageLoad(d);
}.bind(this);d.addEventListener("load",d._defer_load_event);}d._defer_state=c.loading;d.setAttribute("src",d._defer_final_src);
a.imagesLoaded++;if(d.complete){if(!d._defer_state){this.onImageLoad(d);}}else{if(this.options.onImageRequested){this.options.onImageRequested.call(this,d);
}}return true;}return false;}.bind(this);this.unloadImage=function(d){if(d._defer_state&&(d._defer_state!==c.unloading)){d._defer_state=c.unloading;
d.setAttribute("src",d._defer_initial_src);a.imagesLoaded--;if(d.complete){if(d._defer_state){this.onImageLoad(d);
}}return true;}return false;}.bind(this);this.onImageLoad=function(d){if(!d.complete){return;}if(this.urlsMatch(d.src,d._defer_final_src)){d._defer_state=c.loaded;
if(this.options.onImageLoaded){this.options.onImageLoaded.call(this,d);}this.requestCallBack(this.trimImages);
}else{if(this.urlsMatch(d.src,d._defer_initial_src)){d._defer_state=c.unloaded;if(this.options.onImageUnloaded){this.options.onImageUnloaded.call(this,d);
}}}}.bind(this);this.onScroll=function(){var d=Date.now();if(a.scrolling&&(a.scrollInfo.current.time===d)){return;
}a.scrolling=true;a.scrollInfo.last.pos=a.scrollInfo.current.pos;a.scrollInfo.last.time=a.scrollInfo.current.time;
a.scrollInfo.current.pos=this.viewportPos().top;a.scrollInfo.current.time=d;if(!a.scrollChecker){a.scrollChecker=setTimeout(this.peekScroll,this.options.scrollingStopMillis);
}var e=Math.abs((a.scrollInfo.current.pos-a.scrollInfo.last.pos)/(a.scrollInfo.current.time-a.scrollInfo.last.time));
if(e<this.options.scrollingSkipRate){this.requestCallBack(this.lazyLoadImages);}}.bind(this);this.onResize=function(){a.resizing=true;
if(a.resizeChecker){clearTimeout(a.resizeChecker);}a.resizeChecker=setTimeout(function(){a.resizing=false;
a.resizeChecker=null;this.reset();}.bind(this),500);}.bind(this);this.peekScroll=function(){var d=Date.now(),e=a.scrollInfo.current;
if((this.options.scrollingStopMillis||0)<100){this.options.scrollingStopMillis=100;}if((d-e.time>=this.options.scrollingStopMillis*0.9)&&(this.viewportPos().top===e.pos)){a.scrolling=false;
a.scrollChecker=null;this.requestCallBack(this.lazyLoadImages);if(this.options.maxLoaded&&(a.imagesLoaded>this.options.maxLoaded)){this.requestCallBack(this.trimImages);
}}else{a.scrollChecker=setTimeout(this.peekScroll,this.options.scrollingStopMillis);}}.bind(this);this.getBuckets=function(f,d){var e=200;
return{start:Math.floor(f/e),end:Math.floor((f+d)/e)};};this.viewportPos=function(){return{top:window.pageYOffset||document.documentElement.scrollTop||0,height:window.innerHeight||document.documentElement.offsetHeight||0};
};this.elementPos=function(e){var d=e.getBoundingClientRect();return{top:this.viewportPos().top+d.top,height:d.height};
}.bind(this);this.urlsMatch=function(e,d){if(e===d){return true;}this._aEl1=this._aEl1||document.createElement("a");
this._aEl2=this._aEl2||document.createElement("a");this._aEl1.href=e;this._aEl2.href=d;return this._aEl1.href===this._aEl2.href;
}.bind(this);this.reset=function(){a.imagesLoaded=0;a.images=[];a.maxBucket=0;a.lastVisibleBuckets.start=-1;
a.lastVisibleBuckets.end=-1;var d=document.querySelectorAll("img");for(var e=0;e<d.length;e++){this.addImage(d[e]);
}this.requestCallBack(this.lazyLoadImages);}.bind(this);this.addImage=function(e){var i=e.getAttribute("data-defer-src"),g=e.getAttribute("src"),d,f,h;
if(i){d=this.elementPos(e);f=this.getBuckets(d.top,d.height);for(h=f.start;h<=f.end;h++){if(!a.images[h]){a.images[h]=[];
if(h>a.maxBucket){a.maxBucket=h;}}a.images[h].push(e);}if(e._defer_state===undefined){e._defer_initial_src=g;
e._defer_final_src=i;e._defer_state=this.urlsMatch(g,i)?c.loaded:c.unloaded;}if((e._defer_state===c.loaded)||(e._defer_state===c.loading)){a.imagesLoaded++;
}return true;}return false;}.bind(this);this.removeImage=function(g,i){var k=g._defer_final_src,e=g._defer_state,d,f,h,j;
if(k){d=this.elementPos(g);h=this.getBuckets(d.top,d.height);for(j=h.start;j<=h.end;j++){if(a.images[j]){f=a.images[j].indexOf(g);
if(f!==-1){a.images[j].splice(f,1);}}}if(g._defer_load_event){g.removeEventListener("load",g._defer_load_event);
}delete g._defer_load_event;delete g._defer_initial_src;delete g._defer_final_src;delete g._defer_state;
if((e===c.loaded)||(e===c.loading)){a.imagesLoaded--;}else{if(i){g.setAttribute("src",k);}}}}.bind(this);
this.imagesLoaded=function(){return a.imagesLoaded;};this.supportedBrowser=function(){return !!(document.addEventListener&&document.querySelectorAll&&document.documentElement.getBoundingClientRect&&Array.prototype.forEach);
};this.init=function(){window.addEventListener("resize",this.onResize);window.addEventListener("orientationchange",this.onResize);
document.addEventListener("scroll",this.onScroll);this.reset();}.bind(this);}).call(ImageDefer,ImageDefer.options||{});
if(ImageDefer.supportedBrowser()){if(document.readyState!=="loading"){ImageDefer.init();}else{document.addEventListener("DOMContentLoaded",ImageDefer.init);
}}else{if(console&&console.warn){console.warn("image-defer: Unsupported browser");}}